diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/test/channel-access-manager-test.cc ns-3.31/src/wifi/test/channel-access-manager-test.cc
--- ns-3.30.1/src/wifi/test/channel-access-manager-test.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/test/channel-access-manager-test.cc	2020-06-27 17:38:30.000000000 -0700
@@ -717,10 +858,10 @@
   //        |      | <--eifs-->|
   //       30 request access. backoff slots: 4
   StartTest (4, 6, 10);
-  AddDcfState (1);
+  AddTxop (1);
   AddRxErrorEvt (20, 40);
   AddAccessRequest (30, 2, 101, 0);
-  ExpectCollision (30, 4, 0); //backoff: 4 slots
+  ExpectBackoff (30, 4, 0); //backoff: 4 slots
   AddRxOkEvt (69, 6);
   EndTest ();
 
@@ -732,113 +873,113 @@
   // DCF1  |    rx     | sifs  | aifsn | aifsn  | aifsn  |     | sifs | aifsn | aifsn | aifsn | bslot |  tx  |
   //                                                                 94      98     102     106     110    112
   StartTest (4, 6, 10);
-  AddDcfState (1); //high priority DCF
-  AddDcfState (3); //low priority DCF
+  AddTxop (1); //high priority DCF
+  AddTxop (3); //low priority DCF
   AddRxOkEvt (20, 40);
   AddAccessRequest (30, 10, 78, 0);
-  ExpectCollision (30, 2, 0); //backoff: 2 slot
+  ExpectBackoff (30, 2, 0); //backoff: 2 slot
   AddAccessRequest (40, 2, 110, 1);
-  ExpectCollision (40, 0, 1); //backoff: 0 slot
+  ExpectBackoff (40, 0, 1); //backoff: 0 slot
   ExpectInternalCollision (78, 1, 1); //backoff: 1 slot
   EndTest ();
 
   // Test of AckTimeout handling: First queue requests access and ack procedure fails,
-  // inside the ack timeout second queue with higher priority requests access.
+  // inside the Ack timeout second queue with higher priority requests access.
   //
-  //            20           40      50     60  66      76
-  // DCF0 - low  |     tx     | ack timeout |sifs|       |
-  // DCF1 - high |                    |     |sifs|  tx   |
-  //                                  ^ request access
-  StartTest (4, 6, 10);
-  AddDcfState (2); //high priority DCF
-  AddDcfState (0); //low priority DCF
-  AddAccessRequestWithAckTimeout (20, 20, 20, 0);
-  AddAccessRequest (50, 10, 66, 1);
-  ExpectCollision (50, 0, 1);
+  //            20     26      34       54            74     80
+  // DCF1 - low  | sifs | aifsn |   tx   | Ack timeout | sifs |       |
+  // DCF0 - high |                              |      | sifs |  tx   |
+  //                                            ^ request access
+  StartTest (4, 6, 10);
+  AddTxop (0); //high priority DCF
+  AddTxop (2); //low priority DCF
+  AddAccessRequestWithAckTimeout (20, 20, 34, 1);
+  AddAccessRequest (64, 10, 80, 0);
   EndTest ();
 
   // Test of AckTimeout handling:
   //
-  // First queue requests access and ack is 2 us delayed (got ack interval at the picture),
+  // First queue requests access and Ack is 2 us delayed (got Ack interval at the picture),
   // inside this interval second queue with higher priority requests access.
   //
-  //            20           40  41   42    48      58
-  // DCF0 - low  |     tx     |got ack |sifs|       |
-  // DCF1 - high |                |    |sifs|  tx   |
-  //                              ^ request access
-  StartTest (4, 6, 10);
-  AddDcfState (2); //high priority DCF
-  AddDcfState (0); //low priority DCF
-  AddAccessRequestWithSuccessfullAck (20, 20, 20, 2, 0);
-  AddAccessRequest (41, 10, 48, 1);
-  ExpectCollision (41, 0, 1);
+  //            20     26      34           54        56     62
+  // DCF1 - low  | sifs | aifsn |     tx     | got Ack | sifs |       |
+  // DCF0 - high |                                |    | sifs |  tx   |
+  //                                              ^ request access
+  StartTest (4, 6, 10);
+  AddTxop (0); //high priority DCF
+  AddTxop (2); //low priority DCF
+  AddAccessRequestWithSuccessfullAck (20, 20, 34, 2, 1);
+  AddAccessRequest (55, 10, 62, 0);
   EndTest ();
 
   //Repeat the same but with one queue:
-  //            20           40  41   42    48      58
-  // DCF0 - low  |     tx     |got ack |sifs|       |
-  //                              ^ request access
+  //      20     26      34         54     60    62     68      76       80
+  // DCF0  | sifs | aifsn |    tx    | sifs | Ack | sifs | aifsn | bslot0 | tx |
+  //                                           ^ request access
   StartTest (4, 6, 10);
-  AddDcfState (2);
-  AddAccessRequestWithSuccessfullAck (20, 20, 20, 2, 0);
-  AddAccessRequest (41, 10, 56, 0);
-  ExpectCollision (41, 0, 0);
+  AddTxop (2);
+  AddAccessRequest (20, 20, 34, 0);
+  AddRxOkEvt (60, 2); // Ack
+  AddAccessRequest (61, 10, 80, 0);
+  ExpectBackoff (61, 1, 0); // 1 slot
   EndTest ();
 
-  // test simple NAV count. This scenario modelizes a simple DATA+ACK handshake
-  // where the data rate used for the ACK is higher than expected by the DATA source
-  // so, the data exchange completes before the end of nav.
+  // test simple NAV count. This scenario models a simple Data+Ack handshake
+  // where the data rate used for the Ack is higher than expected by the Data source
+  // so, the data exchange completes before the end of NAV.
   StartTest (4, 6, 10);
-  AddDcfState (1);
+  AddTxop (1);
   AddRxOkEvt (20, 40);
   AddNavStart (60, 15);
   AddRxOkEvt (66, 5);
   AddNavStart (71, 0);
   AddAccessRequest (30, 10, 93, 0);
-  ExpectCollision (30, 2, 0); //backoff: 2 slot
+  ExpectBackoff (30, 2, 0); //backoff: 2 slots
   EndTest ();
 
-  // test more complex NAV handling by a CF-poll. This scenario modelizes a
-  // simple DATA+ACK handshake interrupted by a CF-poll which resets the
+  // test more complex NAV handling by a CF-poll. This scenario models a
+  // simple Data+Ack handshake interrupted by a CF-poll which resets the
   // NAV counter.
   StartTest (4, 6, 10);
-  AddDcfState (1);
+  AddTxop (1);
   AddRxOkEvt (20, 40);
   AddNavStart (60, 15);
   AddRxOkEvt (66, 5);
   AddNavReset (71, 2);
   AddAccessRequest (30, 10, 91, 0);
-  ExpectCollision (30, 2, 0); //backoff: 2 slot
+  ExpectBackoff (30, 2, 0); //backoff: 2 slots
   EndTest ();
 
 
+  //  20         60         80     86      94
+  //   |    rx    |   idle   | sifs | aifsn |    tx    |
+  //                         ^ request access
   StartTest (4, 6, 10);
-  AddDcfState (2);
+  AddTxop (2);
   AddRxOkEvt (20, 40);
-  AddAccessRequest (80, 10, 80, 0);
+  AddAccessRequest (80, 10, 94, 0);
   EndTest ();
 
 
   StartTest (4, 6, 10);
-  AddDcfState (2);
+  AddTxop (2);
   AddRxOkEvt (20, 40);
   AddRxOkEvt (78, 8);
   AddAccessRequest (30, 50, 108, 0);
-  ExpectCollision (30, 3, 0); //backoff: 3 slots
+  ExpectBackoff (30, 3, 0); //backoff: 3 slots
   EndTest ();
 
 
   // Channel switching tests
 
-  //  0          20     23      24   25
-  //  | switching | sifs | aifsn | tx |
-  //                |
-  //               21 access request.
+  //  0          20     21     24      25   26
+  //  | switching | idle | sifs | aifsn | tx |
+  //                     ^ access request.
   StartTest (1, 3, 10);
-  AddDcfState (1);
-  AddSwitchingEvt (0,20);
-  AddAccessRequest (21, 1, 24, 0);
-  ExpectCollision (21, 0, 0);
+  AddTxop (1);
+  AddSwitchingEvt (0, 20);
+  AddAccessRequest (21, 1, 25, 0);
   EndTest ();
 
   //  20          40       50     53      54       55        56   57
@@ -847,100 +988,215 @@
   //        30 busy.   45 access request.
   //
   StartTest (1, 3, 10);
-  AddDcfState (1);
+  AddTxop (1);
   AddSwitchingEvt (20,20);
   AddCcaBusyEvt (30,20);
-  ExpectCollision (45, 2, 0); //backoff: 2 slots
+  ExpectBackoff (45, 2, 0); //backoff: 2 slots
   AddAccessRequest (45, 1, 56, 0);
   EndTest ();
 
-  //  20     30          50     53      54   55
-  //   |  rx  | switching | sifs | aifsn | tx |
-  //                        |
-  //                       51 access request.
+  //  20     30          50     51     54      55   56
+  //   |  rx  | switching | idle | sifs | aifsn | tx |
+  //                             ^ access request.
   //
   StartTest (1, 3, 10);
-  AddDcfState (1);
-  AddRxStartEvt (20,40);
-  AddSwitchingEvt (30,20);
-  AddAccessRequest (51, 1, 54, 0);
-  ExpectCollision (51, 0, 0);
+  AddTxop (1);
+  AddRxStartEvt (20, 40);
+  AddSwitchingEvt (30, 20);
+  AddAccessRequest (51, 1, 55, 0);
   EndTest ();
 
-  //  20     30          50     53      54   55
-  //   | busy | switching | sifs | aifsn | tx |
-  //                        |
-  //                       51 access request.
+  //  20     30          50     51     54      55   56
+  //   | busy | switching | idle | sifs | aifsn | tx |
+  //                             ^ access request.
   //
   StartTest (1, 3, 10);
-  AddDcfState (1);
-  AddCcaBusyEvt (20,40);
-  AddSwitchingEvt (30,20);
-  AddAccessRequest (51, 1, 54, 0);
-  ExpectCollision (51, 0, 0);
+  AddTxop (1);
+  AddCcaBusyEvt (20, 40);
+  AddSwitchingEvt (30, 20);
+  AddAccessRequest (51, 1, 55, 0);
   EndTest ();
 
-  //  20      30          50     53      54   55
-  //   |  nav  | switching | sifs | aifsn | tx |
-  //                        |
-  //                       51 access request.
+  //  20      30          50     51     54      55   56
+  //   |  nav  | switching | idle | sifs | aifsn | tx |
+  //                              ^ access request.
   //
   StartTest (1, 3, 10);
-  AddDcfState (1);
+  AddTxop (1);
   AddNavStart (20,40);
   AddSwitchingEvt (30,20);
-  AddAccessRequest (51, 1, 54, 0);
-  ExpectCollision (51, 0, 0);
+  AddAccessRequest (51, 1, 55, 0);
   EndTest ();
 
-  //  20      40             50          55     58      59   60
-  //   |  tx   | ack timeout  | switching | sifs | aifsn | tx |
-  //                  |                     |
-  //                 45 access request.    56 access request.
+  //  20     23      24      44             54          59     60     63      64   65
+  //   | sifs | aifsn |  tx   | Ack timeout  | switching | idle | sifs | aifsn | tx |
+  //                                 |                          |
+  //                                49 access request.          ^ access request.
   //
   StartTest (1, 3, 10);
-  AddDcfState (1);
-  AddAccessRequestWithAckTimeout (20, 20, 20, 0);
-  AddAccessRequest (45, 1, 50, 0);
-  ExpectCollision (45, 0, 0);
-  AddSwitchingEvt (50,5);
-  AddAccessRequest (56, 1, 59, 0);
-  ExpectCollision (56, 0, 0);
-  EndTest ();
-
-  //  20         60     66      70       74       78  80         100    106     110  112
-  //   |    rx    | sifs | aifsn | bslot0 | bslot1 |   | switching | sifs | aifsn | tx |
-  //        |                                                        |
-  //       30 access request.                                      101 access request.
+  AddTxop (1);
+  AddAccessRequestWithAckTimeout (20, 20, 24, 0);
+  AddAccessRequest (49, 1, 54, 0);
+  AddSwitchingEvt (54, 5);
+  AddAccessRequest (60, 1, 64, 0);
+  EndTest ();
+
+  //  20         60     66      70       74       78  80         100    101    107     111  113
+  //   |    rx    | sifs | aifsn | bslot0 | bslot1 |   | switching | idle | sifs | aifsn | tx |
+  //        |                                                             |
+  //       30 access request.                                             ^ access request.
   //
   StartTest (4, 6, 10);
-  AddDcfState (1);
+  AddTxop (1);
   AddRxOkEvt (20,40);
   AddAccessRequest (30, 2, 80, 0);
-  ExpectCollision (30, 4, 0); //backoff: 4 slots
+  ExpectBackoff (30, 4, 0); //backoff: 4 slots
   AddSwitchingEvt (80,20);
-  AddAccessRequest (101, 2, 110, 0);
-  ExpectCollision (101, 0, 0); //backoff: 0 slots
+  AddAccessRequest (101, 2, 111, 0);
+  EndTest ();
+}
+
+/*
+ * Specialization of DoRun () method for EDCA
+ */
+template <>
+void
+ChannelAccessManagerTest<QosTxop>::DoRun (void)
+{
+  // Check alignment at slot boundary after successful reception (backoff = 0):
+  //    20     50     56      60     80
+  //     |  rx  | sifs | aifsn |  tx  |
+  //                |
+  //               52 request access
+  StartTest (4, 6, 10);
+  AddTxop (1);
+  AddRxOkEvt (20, 30);
+  AddAccessRequest (52, 20, 60, 0);
   EndTest ();
+
+  // Check alignment at slot boundary after successful reception (backoff = 0):
+  //    20     50     56      60     80
+  //     |  rx  | sifs | aifsn |  tx  |
+  //                       |
+  //                      58 request access
+  StartTest (4, 6, 10);
+  AddTxop (1);
+  AddRxOkEvt (20, 30);
+  AddAccessRequest (52, 20, 60, 0);
+  EndTest ();
+
+  // Check alignment at slot boundary after successful reception (backoff = 0):
+  //    20     50     56      60     64     84
+  //     |  rx  | sifs | aifsn | idle |  tx  |
+  //                               |
+  //                              62 request access
+  StartTest (4, 6, 10);
+  AddTxop (1);
+  AddRxOkEvt (20, 30);
+  AddAccessRequest (62, 20, 64, 0);
+  EndTest ();
+
+  // Check alignment at slot boundary after failed reception (backoff = 0):
+  //  20         50     56           66             76     96
+  //   |          | <------eifs------>|              |      |
+  //   |    rx    | sifs | acktxttime | sifs + aifsn |  tx  |
+  //                   |
+  //                  55 request access
+  StartTest (4, 6, 10);
+  AddTxop (1);
+  AddRxErrorEvt (20, 30);
+  AddAccessRequest (55, 20, 76, 0);
+  EndTest ();
+
+  // Check alignment at slot boundary after failed reception (backoff = 0):
+  //  20         50     56           66             76     96
+  //   |          | <------eifs------>|              |      |
+  //   |    rx    | sifs | acktxttime | sifs + aifsn |  tx  |
+  //                                        |
+  //                                       70 request access
+  StartTest (4, 6, 10);
+  AddTxop (1);
+  AddRxErrorEvt (20, 30);
+  AddAccessRequest (70, 20, 76, 0);
+  EndTest ();
+
+  // Check alignment at slot boundary after failed reception (backoff = 0):
+  //  20         50     56           66             76     84
+  //   |          | <------eifs------>|              |      |
+  //   |    rx    | sifs | acktxttime | sifs + aifsn | idle |  tx  |
+  //                                                     |
+  //                                                    82 request access
+  StartTest (4, 6, 10);
+  AddTxop (1);
+  AddRxErrorEvt (20, 30);
+  AddAccessRequest (82, 20, 84, 0);
+  EndTest ();
+
+  // Check backoff decrement at slot boundaries. Medium idle during backoff
+  //  20           50     56      60         64         68         72         76     96
+  //   |     rx     | sifs | aifsn |   idle   |   idle   |   idle   |   idle   |  tx  |
+  //      |                        |          |          |          |
+  //     30 request access.    decrement  decrement  decrement  decrement
+  //        backoff slots: 4    slots: 3   slots: 2   slots: 1   slots: 0
+  StartTest (4, 6, 10);
+  AddTxop (1);
+  AddRxOkEvt (20, 30);
+  AddAccessRequest (30, 20, 76, 0);
+  ExpectBackoff (30, 4, 0);
+  EndTest ();
+
+  // Check backoff decrement at slot boundaries. Medium becomes busy during backoff
+  //  20           50     56      60     61     71     77      81         85     87     97    103     107    127
+  //   |     rx     | sifs | aifsn | idle |  rx  | sifs | aifsn |   idle   | idle |  rx  | sifs | aifsn |  tx  |
+  //      |                        |                            |          |
+  //     30 request access.    decrement                    decrement  decrement
+  //        backoff slots: 3    slots: 2                     slots: 1   slots: 0
+  StartTest (4, 6, 10);
+  AddTxop (1);
+  AddRxOkEvt (20, 30);
+  AddRxOkEvt (61, 10);
+  AddRxOkEvt (87, 10);
+  AddAccessRequest (30, 20, 107, 0);
+  ExpectBackoff (30, 3, 0);
+  EndTest ();
+}
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief Txop Test Suite
+ */
+class TxopTestSuite : public TestSuite
+{
+public:
+  TxopTestSuite ();
+};
+
+TxopTestSuite::TxopTestSuite ()
+  : TestSuite ("wifi-devices-dcf", UNIT)
+{
+  AddTestCase (new ChannelAccessManagerTest<Txop>, TestCase::QUICK);
 }
 
+static TxopTestSuite g_dcfTestSuite;
 
 /**
  * \ingroup wifi-test
  * \ingroup tests
  *
- * \brief Dcf Test Suite
+ * \brief QosTxop Test Suite
  */
-class DcfTestSuite : public TestSuite
+class QosTxopTestSuite : public TestSuite
 {
 public:
-  DcfTestSuite ();
+  QosTxopTestSuite ();
 };
 
-DcfTestSuite::DcfTestSuite ()
-  : TestSuite ("devices-wifi-dcf", UNIT)
+QosTxopTestSuite::QosTxopTestSuite ()
+  : TestSuite ("wifi-devices-edca", UNIT)
 {
-  AddTestCase (new ChannelAccessManagerTest, TestCase::QUICK);
+  AddTestCase (new ChannelAccessManagerTest<QosTxop>, TestCase::QUICK);
 }
 
-static DcfTestSuite g_dcfTestSuite;
+static QosTxopTestSuite g_edcaTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/test/examples-to-run.py ns-3.31/src/wifi/test/examples-to-run.py
--- ns-3.30.1/src/wifi/test/examples-to-run.py	2019-08-12 16:43:20.000000000 -0700
+++ ns-3.31/src/wifi/test/examples-to-run.py	2020-06-27 17:38:30.000000000 -0700
@@ -303,11 +303,15 @@
     ("wifi-manager-example --wifiManager=Ideal --standard=802.11ax-2.4GHz --serverChannelWidth=40 --clientChannelWidth=40 --serverShortGuardInterval=800 --clientShortGuardInterval=800 --serverNss=4 --clientNss=4 --stepTime=0.1", "False", "False"),
     ("wifi-manager-example --wifiManager=Ideal --standard=802.11ax-2.4GHz --serverChannelWidth=40 --clientChannelWidth=40 --serverShortGuardInterval=1600 --clientShortGuardInterval=1600 --serverNss=4 --clientNss=4 --stepTime=0.1", "False", "False"),
     ("wifi-manager-example --wifiManager=Ideal --standard=802.11ax-2.4GHz --serverChannelWidth=40 --clientChannelWidth=40 --serverShortGuardInterval=3200 --clientShortGuardInterval=3200 --serverNss=4 --clientNss=4 --stepTime=0.1", "False", "False"),
-    ("test-interference-helper --enableCapture=0 --txPowerA=5 --txPowerB=15 --delay=10 --txModeA=OfdmRate6Mbps --txModeB=OfdmRate6Mbps --checkResults=1 --expectRxASuccessfull=0 --expectRxBSuccessfull=0", "True", "True"),
-    ("test-interference-helper --enableCapture=0 --txPowerA=5 --txPowerB=15  --delay=17 --standard=WIFI_PHY_STANDARD_80211ac --preamble=WIFI_PREAMBLE_VHT --txModeA=VhtMcs0 --txModeB=VhtMcs0 --checkResults=1 --expectRxASuccessfull=0 --expectRxBSuccessfull=0", "True", "True"),
-    ("test-interference-helper --enableCapture=0 --txPowerA=5 --txPowerB=15  --delay=20 --standard=WIFI_PHY_STANDARD_80211ac --preamble=WIFI_PREAMBLE_VHT --txModeA=VhtMcs0 --txModeB=VhtMcs0 --checkResults=1 --expectRxASuccessfull=0 --expectRxBSuccessfull=0", "True", "True"),
-    ("test-interference-helper --enableCapture=0 --txPowerA=5 --txPowerB=15  --delay=30 --standard=WIFI_PHY_STANDARD_80211ac --preamble=WIFI_PREAMBLE_VHT --txModeA=VhtMcs0 --txModeB=VhtMcs0 --checkResults=1 --expectRxASuccessfull=0 --expectRxBSuccessfull=0", "True", "True"),
-    ("test-interference-helper --enableCapture=1 --txPowerA=5 --txPowerB=15 --delay=10 --txModeA=OfdmRate6Mbps --txModeB=OfdmRate6Mbps --checkResults=1 --expectRxASuccessfull=0 --expectRxBSuccessfull=1", "True", "False"),
+    ("wifi-test-interference-helper --enableCapture=0 --txPowerA=5 --txPowerB=15 --delay=10 --txModeA=OfdmRate6Mbps --txModeB=OfdmRate6Mbps --checkResults=1 --expectRxASuccessfull=0 --expectRxBSuccessfull=0", "True", "True"),
+    ("wifi-test-interference-helper --enableCapture=0 --txPowerA=5 --txPowerB=15  --delay=17 --standard=WIFI_PHY_STANDARD_80211ac --preamble=WIFI_PREAMBLE_VHT_SU --txModeA=VhtMcs0 --txModeB=VhtMcs0 --checkResults=1 --expectRxASuccessfull=0 --expectRxBSuccessfull=0", "True", "True"),
+    ("wifi-test-interference-helper --enableCapture=0 --txPowerA=5 --txPowerB=15  --delay=20 --standard=WIFI_PHY_STANDARD_80211ac --preamble=WIFI_PREAMBLE_VHT_SU --txModeA=VhtMcs0 --txModeB=VhtMcs0 --checkResults=1 --expectRxASuccessfull=0 --expectRxBSuccessfull=0", "True", "True"),
+    ("wifi-test-interference-helper --enableCapture=0 --txPowerA=5 --txPowerB=15  --delay=30 --standard=WIFI_PHY_STANDARD_80211ac --preamble=WIFI_PREAMBLE_VHT_SU --txModeA=VhtMcs0 --txModeB=VhtMcs0 --checkResults=1 --expectRxASuccessfull=0 --expectRxBSuccessfull=0", "True", "True"),
+    ("wifi-test-interference-helper --enableCapture=1 --txPowerA=5 --txPowerB=15 --delay=10 --txModeA=OfdmRate6Mbps --txModeB=OfdmRate6Mbps --checkResults=1 --expectRxASuccessfull=0 --expectRxBSuccessfull=1", "True", "False"),
+    ("wifi-bianchi --validate --phyRate=54 --nMinStas=5 --nMaxStas=10 --duration=5", "False", "False"), # TODO: run from N=5 to N=50 for 100s (TAKES_FOREVER) when issue #170 is fixed
+    ("wifi-bianchi --validate --phyRate=6 --nMinStas=5 --nMaxStas=10 --duration=15", "True", "False"), # TODO: run from N=5 to N=50 for 400s (TAKES_FOREVER) when issue #170 is fixed
+    ("wifi-bianchi --validate --phyRate=54 --nMinStas=5 --nMaxStas=10 --duration=5 --infra", "False", "False"), # TODO: run from N=5 to N=50 for 100s (TAKES_FOREVER) when issue #170 is fixed
+    ("wifi-bianchi --validate --phyRate=6 --nMinStas=5 --nMaxStas=10 --duration=20 --infra", "False", "False"), # TODO: run from N=5 to N=50 for 600s (TAKES_FOREVER) when issue #170 is fixed
 ]
 
 # A list of Python examples to run in order to ensure that they remain
